## net.sf.saxon.functions
Class DistinctValues.DistinctIterator

    java.lang.Object
      net.sf.saxon.functions.DistinctValues.DistinctIterator

All Implemented Interfaces:
  SequenceIterator

Enclosing class:
  DistinctValues

public static class DistinctValues.DistinctIterator
extends java.lang.Object
implements SequenceIterator

Iterator class to return the distinct values in a sequence

Constructor Summary
`DistinctValues.DistinctIterator(SequenceIterator base, AtomicSortComparer comparer)` Create an iterator over the distinct values in a sequence

Method Summary
`Item` `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
`SequenceIterator` `getAnother()` Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.
`Item` `next()` Get the next item in the sequence.
`int` `position()` Get the current position.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DistinctValues.DistinctIterator

    public DistinctValues.DistinctIterator(SequenceIterator base,
                                           AtomicSortComparer comparer)

  Create an iterator over the distinct values in a sequence

Parameters:
  `base` - the input sequence. This must return atomic values only.
  `comparer` - The comparer used to obtain comparison keys from each value; these comparison keys are themselves compared using equals().

Method Detail

### next

    public Item next()
              throws XPathException

  Get the next item in the sequence.

  Specified by:
    `next` in interface `SequenceIterator`
  Returns:
    the next item, or null if there are no more items.
  Throws:
    `XPathException` - if an error occurs retrieving the next item

### current

    public Item current()

  Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next().

  Specified by:
    `current` in interface `SequenceIterator`
  Returns:
    the current item, the one most recently returned by a call on next(); or null, if next() has not been called, or if the end of the sequence has been reached.

### position

    public int position()

  Get the current position. This will be zero before the first call on next(), otherwise it will be the number of times that next() has been called.

  Specified by:
    `position` in interface `SequenceIterator`
  Returns:
    the current position, the position of the item returned by the most recent call of next()

### getAnother

    public SequenceIterator getAnother()
                                throws XPathException

  Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Returns:
    a SequenceIterator that iterates over the same items, positioned before the first item
  Throws:
    `XPathException` - if any error occurs